# Hello World Plugin for Cthulhu

This is a simple test plugin for the Cthulhu screen reader that demonstrates how to use the pluggy-based plugin system.

## Features

- Registers a keyboard shortcut (Cthulhu+z) that speaks "hello world" when pressed
- Demonstrates how to use the Plugin base class
- Shows how to use cthulhu_hookimpl for hook implementation

## Implementation Details

The plugin uses the following key features:
- `pluggy` for hook specification and implementation
- The `Plugin` base class from cthulhu.plugin
- The `cthulhu_hookimpl` decorator to mark functions as plugin hooks
- The `registerGestureByString` method to register keyboard shortcuts

## Structure

- `plugin.py`: The main plugin implementation
- `plugin.info`: Metadata about the plugin

## Requirements

Requires the pluggy package to be installed:
```
pip install pluggy
```

## Usage

The plugin will be automatically loaded when Cthulhu starts if it's listed in the activePlugins setting.