#!/usr/bin/env python3
#
# Copyright (c) 2024 Stormux
# Copyright (c) 2010-2012 The Orca Team
# Copyright (c) 2012 Igalia, S.L.
# Copyright (c) 2005-2010 Sun Microsystems Inc.
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., Franklin Street, Fifth Floor,
# Boston MA  02110-1301 USA.
#
# Fork of Orca Screen Reader (GNOME)
# Original source: https://gitlab.gnome.org/GNOME/orca

from macaroon.playback import *
import utils

sequence = MacroSequence()

#sequence.append(WaitForDocLoad())
sequence.append(PauseAction(5000))

sequence.append(utils.StartRecordingAction())
sequence.append(KeyComboAction("KP_Enter"))
sequence.append(utils.AssertPresentationAction(
    "1. Where Am I on image",
    ["KNOWN ISSUE: 'Empty images are exposed to us as text, without AtspiAction, and the Firefox right-click menu lacks View Description",
     "BRAILLE LINE:  'the image'",
     "     VISIBLE:  'the image', cursor=1",
     "SPEECH OUTPUT: 'the image'"]))

#sequence.append(PauseAction(3000))
#sequence.append(KeyComboAction("KP_Multiply"))
#sequence.append(PauseAction(3000))
#sequence.append(KeyComboAction("d"))
##sequence.append(WaitForDocLoad())
sequence.append(PauseAction(5000))
#
#sequence.append(utils.StartRecordingAction())
#sequence.append(KeyComboAction("KP_Enter"))
#sequence.append(utils.AssertPresentationAction(
#    "2. Having selected View Description, do a Where Am I for new location", 
#    ["BRAILLE LINE:  'Pass h1'",
#     "     VISIBLE:  'Pass h1', cursor=1",
#     "SPEECH OUTPUT: 'heading level 1'",
#     "SPEECH OUTPUT: 'Pass'"]))

sequence.append(utils.AssertionSummaryAction())
sequence.start()
